hdu 4035 Maze 概率dp

16 篇文章 0 订阅

Maze

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65768/65768 K (Java/Others)
Total Submission(s): 1678    Accepted Submission(s): 639
Special Judge


Problem Description
When wake up, lxhgww find himself in a huge maze.

The maze consisted by N rooms and tunnels connecting these rooms. Each pair of rooms is connected by one and only one path. Initially, lxhgww is in room 1. Each room has a dangerous trap. When lxhgww step into a room, he has a possibility to be killed and restart from room 1. Every room also has a hidden exit. Each time lxhgww comes to a room, he has chance to find the exit and escape from this maze.

Unfortunately, lxhgww has no idea about the structure of the whole maze. Therefore, he just chooses a tunnel randomly each time. When he is in a room, he has the same possibility to choose any tunnel connecting that room (including the tunnel he used to come to that room).
What is the expect number of tunnels he go through before he find the exit?
 

Input
First line is an integer T (T ≤ 30), the number of test cases.

At the beginning of each case is an integer N (2 ≤ N ≤ 10000), indicates the number of rooms in this case.

Then N-1 pairs of integers X, Y (1 ≤ X, Y ≤ N, X ≠ Y) are given, indicate there is a tunnel between room X and room Y.

Finally, N pairs of integers Ki and Ei (0 ≤ Ki, Ei ≤ 100, Ki + Ei ≤ 100, K1 = E1 = 0) are given, indicate the percent of the possibility of been killed and exit in the ith room.
 

Output
For each test case, output one line “Case k: ”. k is the case id, then the expect number of tunnels lxhgww go through before he exit. The answer with relative error less than 0.0001 will get accepted. If it is not possible to escape from the maze, output “impossible”.
 

Sample Input
  
  
3 3 1 2 1 3 0 0 100 0 0 100 3 1 2 2 3 0 0 100 0 0 100 6 1 2 2 3 1 4 4 5 4 6 0 0 20 30 40 30 50 50 70 10 20 60
 

Sample Output
  
  
Case 1: 2.000000 Case 2: impossible Case 3: 2.895522
 

Source
 

Recommend
lcy
 

题意:一棵树,从点1出发,每到另一个节点有3种可能:

      1.被杀死,回到点1,概率为ki

      2.逃出去,走出迷宫,概率为ei

      3.接着走,概率等分

求走出去的步数期望。

思路:做概率题做得少,思路自己推了一半,最后还是看了别人的做法,结果发现自己思路其实是对的。

具体太复杂,还是看kuangbin大神的思路

http://www.cnblogs.com/kuangbin/archive/2012/10/03/2711108.html

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <queue>
#include <map>
using namespace std;
const int mod=1e9+7;
const int N=100010;
const double eps=1e-9;
double dp[N],A[N],B[N],C[N],k[N],e[N];
int n,t,e1,e2;
vector <int> edge[N];
void init(){
    scanf("%d",&n);
    memset(edge,0,sizeof(edge));
    for(int i=1;i<n;i++){
        scanf("%d%d",&e1,&e2);
        edge[e1].push_back(e2);
        edge[e2].push_back(e1);
    }
    for(int i=1;i<=n;i++){
        scanf("%lf%lf",&k[i],&e[i]);
        k[i]/=100;
        e[i]/=100;
    }
}
bool dfs(int t,int r){
    int m=edge[t].size();
    A[t]=k[t];
    B[t]=(1-k[t]-e[t])/m;
    C[t]=1-k[t]-e[t];
    double tmp=0;
    for(int i=0;i<m;i++){
        if(edge[t][i]==r)continue;
        if(!dfs(edge[t][i],t))return 0;
        A[t]+=(1-k[t]-e[t])/m*A[edge[t][i]];
        C[t]+=(1-k[t]-e[t])/m*C[edge[t][i]];
        tmp+=(1-k[t]-e[t])/m*B[edge[t][i]];
    }
    if(fabs(tmp-1)<eps)return 0;
    A[t]/=(1-tmp);
    B[t]/=(1-tmp);
    C[t]/=(1-tmp);
    return 1;
}
int main(){
    scanf("%d",&t);
    int cas=1;
    while(t--){
        init();
        printf("Case %d: ",cas++);
        if(dfs(1,-1)&&fabs(1-A[1])>eps){
            printf("%f\n",C[1]/(1-A[1]));
        }
        else printf("impossible\n");
    }
    return 0;
}



  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值